## pakcs 1.14.1

=== Makefile ===
#****************************************************************************
# PAKCS: The Portland Aachen Kiel Curry System
# ============================================
#
# A Prolog-based implementation of the functional logic language Curry
# developed by
#
# Sergio Antoy, Bernd Brassel, Martin Engelke, Michael Hanus, Klaus Hoeppner,
# Johannes Koj, Philipp Niederau, Ramin Sadre, Frank Steiner
#
# (contact: pakcs@curry-language.org)
#****************************************************************************

# Some information about this installation
# ----------------------------------------

# Is this an installation for a distribution (yes|no)?
# If yes, nothing will be stored in the home directory.
export DISTINSTALL = no

# The major version numbers:
MAJORVERSION=1
# The minor version number:
MINORVERSION=14
# The revision version number:
REVISIONVERSION=1
# The build version number:
BUILDVERSION=2
# Complete version:
VERSION=$(MAJORVERSION).$(MINORVERSION).$(REVISIONVERSION)
# The version date:
COMPILERDATE := $(shell git log -1 --format="%ci" | cut -c-10)
# The name of the Curry system, needed for installation of system libraries:
export CURRYSYSTEM=pakcs

# Paths used in this installation
# -------------------------------

# the root directory of the installation
export ROOT=$(CURDIR)
# binary directory and executables
export BINDIR=$(ROOT)/bin
# Directory where the front end is located
export FRONTENDDIR   = $(ROOT)/frontend
# Directory where the sources of the standard libraries are located
export LIBSRCDIR     = $(ROOT)/lib-trunk
# Directory where the actual libraries are located
export LIBDIR        = $(ROOT)/lib
# Directory where the documentation files are located
export DOCDIR        = $(ROOT)/docs
# The version information file for Curry2Prolog:
C2PVERSION=$(ROOT)/curry2prolog/pakcsversion.pl
# The version information file for the manual:
MANUALVERSION=$(DOCDIR)/src/version.tex

# Various executables used in the installation
# --------------------------------------------

# The REPL binary, used for building various tools
export REPL         = $(BINDIR)/$(CURRYSYSTEM)
# The default options for the REPL
export REPL_OPTS    = --noreadline :set -time
# The front end binary
export CYMAKE       = $(BINDIR)/cymake
# The cleancurry binary
export CLEANCURRY   = $(BINDIR)/cleancurry

# Logfile for make:
MAKELOG=make.log

########################################################################
# The targets
########################################################################

#
# Install all components of PAKCS
#
.PHONY: all
all:
	@rm -f $(MAKELOG)
	@echo "Make started at `date`" > $(MAKELOG)
	$(MAKE) config  2>&1 | tee -a $(MAKELOG)
	$(MAKE) install 2>&1 | tee -a $(MAKELOG)
	@echo "Make finished at `date`" >> $(MAKELOG)
	@echo "Make process logged in file $(MAKELOG)"

#
# Install all components of PAKCS
#
.PHONY: install
install: installscripts copylibs
	@echo "PAKCS installation configuration (file pakcsinitrc):"
	@cat pakcsinitrc
	# install front end (if sources are present):
	@if [ -d $(FRONTENDDIR) ] ; then $(MAKE) frontend ; fi
	# pre-compile all libraries:
	@cd lib && $(MAKE) fcy
	# install the Curry2Prolog compiler as a saved system:
	$(MAKE) $(C2PVERSION)
	cd curry2prolog && $(MAKE)
	# compile all libraries:
	@cd lib && $(MAKE) acy
	# compile optimization tools:
	@cd currytools/optimize && $(MAKE)
	# prepare for separate compilation: compile all libraries to Prolog
	@if [ -r bin/pakcs ] ; then cd lib && $(MAKE) pl ; fi
	$(MAKE) tools
	$(MAKE) docs
	chmod -R go+rX .

# Clean old files that might be in conflict with newer versions of PAKCS:
.PHONY: cleanoldinfos
cleanoldinfos:
	# delete old RequiredValue analysis files since format has changed:
	@if [ -d $(HOME)/.curry/Analysis ] ; then \
	  find $(HOME)/.curry/Analysis -name \*.RequiredValue.p\* -exec rm -f \{\} \; ; fi

# Configure installation w.r.t. variables in pakcsinitrc:
.PHONY: config
config: installscripts
	@scripts/configure-pakcs

# install the scripts of PAKCS in the bin directory:
.PHONY: installscripts
installscripts:
	cd scripts && $(MAKE) all

# remove the scripts of PAKCS in the bin directory:
.PHONY: cleanscripts
cleanscripts:
	cd scripts && $(MAKE) clean

# install the library sources from the trunk directory:
.PHONY: copylibs
copylibs:
	@if [ -d $(LIBSRCDIR) ] ; then cd $(LIBSRCDIR) && $(MAKE) -f Makefile.$(CURRYSYSTEM).install ; fi

# install front end (if sources are present):
.PHONY: frontend
frontend:
	rm -f $(CYMAKE)
	cd $(FRONTENDDIR) && $(MAKE)
	ln -s $(FRONTENDDIR)/bin/cymake $(CYMAKE)

# compile the tools:
.PHONY: tools
tools:
	# compile the Curry Port Name Server demon:
	@if [ -r bin/pakcs ] ; then cd cpns       && $(MAKE) ; fi
	# compile the event handler demon for dynamic web pages:
	@if [ -r bin/pakcs ] ; then cd www        && $(MAKE) ; fi
	@if [ -r bin/pakcs ] ; then cd currytools && $(MAKE) ; fi
	@if [ -r bin/pakcs ] ; then cd tools      && $(MAKE) ; fi

# compile documentation, if necessary:
.PHONY: docs
docs:
	@if [ -d $(DOCDIR)/src ] ; \
	 then $(MAKE) $(MANUALVERSION) && cd $(DOCDIR)/src && $(MAKE) install ; fi

# Create file with version information for Curry2Prolog:
$(C2PVERSION): Makefile
	echo ':- module(pakcsversion,[compilerVersion/1, compilerMajorVersion/1, compilerMinorVersion/1, compilerRevisionVersion/1, buildVersion/1, buildDate/1, installDir/1]).' > $@
	echo "compilerVersion('PAKCS$(MAJORVERSION).$(MINORVERSION)')." >> $@
	echo 'compilerMajorVersion($(MAJORVERSION)).' >> $@
	echo 'compilerMinorVersion($(MINORVERSION)).' >> $@
	echo 'compilerRevisionVersion($(REVISIONVERSION)).' >> $@
	echo 'buildVersion($(BUILDVERSION)).' >> $@
	echo "buildDate('$(COMPILERDATE)')." >> $@
	echo "installDir('$(ROOT)')." >> $@

# Create file with version information for the manual:
$(MANUALVERSION): Makefile
	echo '\\newcommand{\\pakcsversion}{$(VERSION)}' > $@
	echo '\\newcommand{\\pakcsversiondate}{Version of $(COMPILERDATE)}' >> $@

#
# Create documentation for system libraries:
#
.PHONY: libdoc
libdoc:
	@if [ ! -r bin/currydoc ] ; then \
	  echo "Cannot create library documentation: currydoc not available!" ; exit 1 ; fi
	@rm -f $(MAKELOG)
	@echo "Make libdoc started at `date`" > $(MAKELOG)
	@cd lib && $(MAKE) doc 2>&1 | tee -a ../$(MAKELOG)
	@echo "Make libdoc finished at `date`" >> $(MAKELOG)
	@echo "Make libdoc process logged in file $(MAKELOG)"

# run the test suites to check the installation
.PHONY: runtest
runtest: testsuite/doTest
	#cd testsuite && ./doTest --nogui
	cd testsuite2 && ./test.sh
	cd lib && ./test.sh
	cd currytools && $(MAKE) runtest
	cd examples/CHR && ./test.sh

$(CLEANCURRY):
	cd scripts && $(MAKE) $@

# Clean the system files, i.e., remove the installed PAKCS components
# except for the front end
.PHONY: clean
clean: $(CLEANCURRY)
	rm -f $(MAKELOG)
	$(MAKE) cleantools
	if [ -d lib ] ; then cd lib && $(MAKE) clean ; fi
	cd examples && $(CLEANCURRY) -r
	if [ -d $(DOCDIR)/src ] ; then cd $(DOCDIR)/src && $(MAKE) clean ; fi
	cd bin && rm -f sicstusprolog swiprolog
	cd scripts && $(MAKE) clean
	if [ -d $(FRONTENDDIR) ] ; then cd $(FRONTENDDIR) && $(MAKE) clean ; fi

# Clean the generated PAKCS tools
.PHONY: cleantools
cleantools: $(CLEANCURRY)
	cd curry2prolog && $(MAKE) clean
	cd currytools && $(MAKE) uninstall
	cd tools && $(MAKE) clean
	cd cpns && $(MAKE) clean
	cd www && $(MAKE) clean
	cd bin && rm -f pakcs

# Clean everything (including the front end)
.PHONY: cleanall
cleanall: clean
	rm -rf $(LIBDIR)
	-cd $(FRONTENDDIR) && $(MAKE) cleanall
	if [ -d $(FRONTENDDIR) ]; then rm -rf $(BINDIR); fi
	rm -f pakcsinitrc pakcsinitrc.bak


################################DISTRIBUTION##################################
# Create distribution versions of the complete system as tar files
# pakcs*.tar.gz:

# directory name of distribution
FULLNAME    = pakcs-$(VERSION)
# temporary directory to create distribution version
PAKCSDIST   = $(FULLNAME)
# architecture name
ARCH        = $(shell dpkg-architecture -qDEB_BUILD_ARCH)-$(shell uname -s)
# Files to be excluded for source distribution
SRC_EXCLUDE = --exclude=bin
# Files to be excluded for binary distribution
BIN_EXCLUDE = --exclude=frontend
# date of distribution
DIST_DATE   = $(shell date +%Y%m%d)

.PHONY: dist
dist:
	rm -rf pakcs*.tar.gz $(PAKCSDIST) # remove any old distribution
	git clone . $(PAKCSDIST)          # create copy of git version
	cd $(PAKCSDIST) && git submodule init && git submodule update
	cd $(PAKCSDIST) && $(MAKE) copylibs
	cd $(PAKCSDIST) && $(MAKE) cleandist # delete unnessary files
	mkdir -p $(PAKCSDIST)/bin && cp -p $(CYMAKE) $(PAKCSDIST)/bin
	cp -p docs/Manual.pdf docs/markdown_syntax.html $(PAKCSDIST)/docs
	cat Makefile | sed -e "/#DISTRIBUTION#/,\$$d" \
	             | sed 's|^COMPILERDATE *:=.*$$|COMPILERDATE =$(COMPILERDATE)|' \
	             > $(PAKCSDIST)/Makefile
	tar cfvz $(FULLNAME)-src.tar.gz     $(SRC_EXCLUDE) $(PAKCSDIST)
	tar cfvz $(FULLNAME)-$(ARCH).tar.gz $(BIN_EXCLUDE) $(PAKCSDIST)
	rm -rf $(PAKCSDIST)
	@echo "----------------------------------------------------------------"
	@echo "Distribution files pakcs*.tar.gz generated."

.PHONY: distdated
distdated: dist
	mv $(FULLNAME)-src.tar.gz     $(FULLNAME)-$(DIST_DATE)-src.tar.gz
	mv $(FULLNAME)-$(ARCH).tar.gz $(FULLNAME)-$(DIST_DATE)-$(ARCH).tar.gz

# Clean all files that should not be included in a distribution
.PHONY: cleandist
cleandist:
	rm -rf .git .gitmodules .gitignore
	rm -rf $(LIBSRCDIR)
	rm -rf currytools/.git currytools/.gitignore
	cd $(FRONTENDDIR)/curry-base     && rm -rf .git .gitignore dist
	cd $(FRONTENDDIR)/curry-frontend && rm -rf .git .gitignore dist
	rm -rf docs/src
	rm -f KNOWN_BUGS CHANGELOG.html

=== cpns/Makefile ===
# Translate CPNS demon for fast startup:

# Required:
# - installed Curry system (REPL)

LOGFILE="/tmp/CurryPNSD.log"

CPNSD: ../lib/CPNS.curry CPNSD.curry
	$(REPL) $(REPL_OPTS) :load CPNSD :save :q

# Shows the currently registered ports:
.PHONY: show
show: CPNSD
	./CPNSD show

# Shows the log file of the demon:
.PHONY: showlog
showlog: 
	cat $(LOGFILE)

.PHONY: clean
clean: 
	./stop
	$(CLEANCURRY)
	rm -f CPNSD

=== curry2prolog/Makefile ===
########################################################################
# Makefile for the Curry->Prolog compiler system of PAKCS
########################################################################

# define environment variable PAKCSHOME:
PAKCSHOME=$(dir $(CURDIR))

# The SICStus Prolog interpreter:
SICSTUS=$(PAKCSHOME)/bin/sicstusprolog

# The SWI-Prolog interpreter:
SWI=$(PAKCSHOME)/bin/swiprolog

# Standard options for SWI-Prolog
SWIOPTIONS=--traditional -q -L0 -G0 -T0 -O

# librariry directory of PAKCS:
LIBDIR=$(PAKCSHOME)/lib

# standard name in bin directory:
INSTALLBIN = ../bin/curry

.PHONY: install
install:
	$(MAKE) uninstall
	@if [ -x "$(SICSTUS)" ] ; then $(MAKE) sicstus ; elif [ -x "$(SWI)" ] ; then $(MAKE) swi ; else echo "No Prolog defined to generate Curry->Prolog compiler" ; exit 1 ; fi
	../bin/.makesavedstate c2p.state
	rm -f pakcs
	mv c2p.state pakcs
	ln -s $(PAKCSHOME)/bin/pakcs $(INSTALLBIN)

.PHONY: uninstall
uninstall:
	rm -f $(INSTALLBIN)

# make everything if we have a SICStus-Prolog system:
.PHONY: sicstus
sicstus:
	echo "[sicstusbasics], generatePrologBasics." | "$(SICSTUS)"
	$(MAKE) c2p.state

# make everything if we have a SWI-Prolog system:
.PHONY: swi
swi:
	$(MAKE) libswi
	rm -f prologbasics.pl ; cp swibasics.pl prologbasics.pl
	$(MAKE) swi.state
	mv -f swi.state c2p.state

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SICStus-Prolog
#
c2p.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readFlcFromFcy.pl \
	      lib_src/prim_readshowterm.pl \
	      readXml.pl $(LIBDIR)/.curry/Prelude.fcy
	echo "compile(c2p),c2p('$(LIBDIR)/Prelude'),compile('$(LIBDIR)/.curry/pakcs/Prelude'),loadAndCompile('$(LIBDIR)/.curry/pakcs/Prelude.pl',[],create),saveprog_entry('c2p.state',user:pakcsMain)." \
           | "$(SICSTUS)"

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SWI-Prolog
#
swi.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readFlcFromFcy.pl \
	      lib_src/prim_readshowterm.pl \
	      readXml.pl $(LIBDIR)/.curry/Prelude.fcy
	echo "compile(c2p). c2p('$(LIBDIR)/Prelude'), compile('$(PAKCSHOME)/lib/.curry/pakcs/Prelude'),loader:loadAndCompile('$(PAKCSHOME)/lib/.curry/pakcs/Prelude.pl',[],create). saveprog_entry('swi.state',user:pakcsMain)." | "$(SWI)" $(SWIOPTIONS)

$(LIBDIR)/.curry/Prelude.fcy: $(LIBDIR)/Prelude.curry
	cd $(LIBDIR) && $(MAKE) .curry/Prelude.fcy

#
# generate correct versions of run-time libraries for SWI-Prolog
#
PRIMLIBSRC = `cd lib_src && echo *.pl`

.PHONY: libswi
libswi:
	@mkdir -p libswi
	@for i in $(PRIMLIBSRC) ; do $(MAKE) libswi/$$i ; done

libswi/%.pl: lib_src/%.pl
	echo "[block2freeze]. transFile('$*.pl')." | "$(SWI)" $(SWIOPTIONS)

# clean up everything
.PHONY: clean
clean: uninstall
	rm -f c2p.state pakcs $(LIBDIR)/.curry/pakcs/Prelude.pl ../bin/pakcs prologbasics.pl
	rm -f pakcsversion.pl
	rm -rf libswi/

=== frontend/Makefile ===
##############################################################################
# Makefile for installing the Curry front end
##############################################################################

# the root directory of the installation
export ROOT=$(CURDIR)
# binary directory and executables
export BINDIR=$(ROOT)/bin
# The frontend binary
export CYMAKE = $(BINDIR)/cymake

# GHC and CABAL configuration (for installing the front end)
# ----------------------------------------------------------
# The path to the Glasgow Haskell Compiler and Cabal
export GHC     := $(shell which ghc)
export GHC-PKG := $(shell dirname "$(GHC)")/ghc-pkg
export CABAL    = cabal

# Because of an API change in GHC 7.6,
# we need to distinguish GHC < 7.6 and GHC >= 7.6.
# GHC 7.6 renamed the option "package-conf" to "package-db".

# extract GHC version
ifdef GHC
GHC_MAJOR := $(shell "$(GHC)" --numeric-version | cut -d. -f1)
GHC_MINOR := $(shell "$(GHC)" --numeric-version | cut -d. -f2)
# Is the GHC version >= 7.6 ?
GHC_GEQ_76 = $(shell test $(GHC_MAJOR) -gt 7 -o \( $(GHC_MAJOR) -eq 7 \
              -a $(GHC_MINOR) -ge 6 \) ; echo $$?)
# package-db (>= 7.6) or package-conf (< 7.6)?
ifeq ($(GHC_GEQ_76),0)
GHC_PKG_OPT = package-db
else
GHC_PKG_OPT = package-conf
endif
endif

# Command to unregister a package
export GHC_UNREGISTER = "$(GHC-PKG)" unregister --$(GHC_PKG_OPT)="$(PKGDB)"
# Command to install missing packages using cabal
export CABAL_INSTALL  = "$(CABAL)" install --with-compiler="$(GHC)"       \
                        --with-hc-pkg="$(GHC-PKG)" --prefix="$(LOCALPKG)" \
                        --global --package-db="$(PKGDB)" -O2

# Directory where local package installations are stored
export LOCALPKG      = $(ROOT)/pkg
# The path to the package database
export PKGDB         = $(LOCALPKG)/pakcs.conf.d

##############################################################################
# Retrieve all Haskell modules as dependencies for cymake
DEPS := $(shell find curry-base/src/ curry-frontend/src/ -type f)

# install front end (if sources are present):
.PHONY: frontend
frontend:
ifdef GHC
	$(MAKE) $(PKGDB)
	$(MAKE) $(CYMAKE)
else
	@echo "GHC missing, cannot build front end!"
	@exit 1
endif

# create package database
$(PKGDB):
	"$(GHC-PKG)" init $@
	$(CABAL) update

# install the sources of the front end from its repository
$(CYMAKE): $(DEPS)
	$(MAKE) unregister
	mkdir -p $(@D)
	cd curry-base     && $(CABAL_INSTALL)
	$(MAKE) transformers # see below
	cd curry-frontend && $(CABAL_INSTALL) --bindir=$(@D)

# Temporary workaround for https://github.com/haskell/cabal/issues/1855
# see also http://www.haskell.org/pipermail/cabal-devel/2014-May/009795.html
.PHONY: transformers
transformers:
	$(CABAL_INSTALL) transformers-compat -f transformers3

# unregister previous version to avoid cabal install failures
.PHONY: unregister
unregister:
	-$(GHC_UNREGISTER) curry-frontend
	-$(GHC_UNREGISTER) curry-base

.PHONY: clean
clean:
	cd curry-base     && $(CABAL) clean
	cd curry-frontend && $(CABAL) clean

.PHONY: cleanall
cleanall:
	cd curry-base     && rm -rf dist/
	cd curry-frontend && rm -rf dist/
	rm -rf $(LOCALPKG)
	rm -f $(CYMAKE)   && rm -rf bin

=== scripts/Makefile ===
##############################################################################
# Installation of PAKCS shell scripts
##############################################################################

# the scripts to be installed
BINS = $(BINDIR)/pakcs $(BINDIR)/makecurrycgi \
       $(BINDIR)/.makesavedstate $(BINDIR)/parsecurry $(BINDIR)/cleancurry \
       $(BINDIR)/fcypp # $(BINDIR)/runcurry


.PHONY: all
all:
	@if [ ! -d $(BINDIR) ] ; then mkdir -p $(BINDIR) ; fi
	$(MAKE) $(BINS)

# install some script of PAKCS in the bin directory:
$(BINDIR)/%: %.sh
	mkdir -p $(@D)
	sed "s|^PAKCSHOME=.*$$|PAKCSHOME=$(ROOT)|" < $< > $@
	chmod 755 $@

.PHONY: clean
clean:
	rm -f $(BINS)

=== www/Makefile ===
# Translate programs for managing cgi server processes:

.PHONY: all
all: submitform Registry

submitform: SubmitForm.curry $(LIBDIR)/HtmlCgi.curry \
	    $(LIBDIR)/NamedSocket.curry $(LIBDIR)/CPNS.curry
	$(REPL) $(REPL_OPTS) :load SubmitForm :save :q
	mv SubmitForm submitform

Registry: Registry.curry $(LIBDIR)/HtmlCgi.curry
	$(REPL) $(REPL_OPTS) :load Registry :save :q

.PHONY: cleanServers
cleanServers:
	./Registry clean

.PHONY: show
show:
	./Registry show

.PHONY: showload
showload:
	./Registry showload

.PHONY: sketch
sketch:
	./Registry sketch

.PHONY: showall
showall:
	./Registry showall

.PHONY: stop
stop:
	./Registry stop

.PHONY: kill
kill:
	./Registry kill

.PHONY: clean
clean:
	rm -f submitform Registry
	$(CLEANCURRY)

=== docs/src/Makefile ===
# To format the user manual

PAKCS=../../bin/pakcs

.PHONY: pdf
pdf : manual.pdf

manual.pdf: $(wildcard *.tex lib/*.tex ../../currytools/*/Docs/*.tex) \
	    markdown_syntax.tex
	pdflatex manual
	bibtex manual
	pdflatex manual
	makeindex manual.idx
	pdflatex manual

../Manual.pdf: manual.pdf
	thumbpdf manual
	pdflatex manual
	rm -f $@
	cp $< $@

markdown_syntax.tex: markdown_syntax.txt
	$(PAKCS) :l Markdown :eval 'readFile "$<" >>= writeFile "$@" . markdownText2LaTeX' :quit

../markdown_syntax.html: markdown_syntax.txt
	$(PAKCS) :l Markdown :eval 'readFile "$<" >>= writeFile "$@" . markdownText2CompleteHTML "Markdown Syntax"' :quit

# format installation description as HTML page
../INSTALL.html: ../../INSTALL.txt
	$(PAKCS) :l Markdown :eval 'readFile "$<" >>= writeFile "$@" . markdownText2CompleteHTML "PAKCS Installation Instructions"' :quit

# format repository installation description as HTML page
../GITINSTALL.html: ../../GITINSTALL.txt
	$(PAKCS) :l Markdown :eval 'readFile "$<" >>= writeFile "$@" . markdownText2CompleteHTML "PAKCS Repository"' :quit

# format release notes as HTML page
../RELNOTES.html: ../../RELNOTES.txt
	$(PAKCS) :l Markdown :eval 'readFile "$<" >>= writeFile "$@" . markdownText2CompleteHTML "PAKCS Release Notes"' :quit

# generate documentation for all libraries
.PHONY: libdoc
libdoc:
	@cd ../../lib && $(MAKE) texdoc

.PHONY: install
install:
	$(MAKE) ../markdown_syntax.html
	$(MAKE) ../INSTALL.html
	$(MAKE) ../GITINSTALL.html
	$(MAKE) ../RELNOTES.html
	$(MAKE) libdoc
	$(MAKE) ../Manual.pdf

.PHONY: clean
clean:
	rm -f markdown_syntax.tex ../markdown_syntax.html \
	           ../INSTALL.html ../GITINSTALL.html ../RELNOTES.html
	rm -f *.aux *.bbl *.blg *.idx *.ilg *.ind *.log *.out *.pdf *.toc *.tpt
	rm -rf lib
	rm -f ../Manual.pdf ../Manual.ps.gz thumb* version.tex

=== tools/coosy/Makefile ===
# Makefile for generating Curry Observer:

.PHONY: all
all: CoosyGUI

# generate executable for CoosyGUI:
CoosyGUI: CoosyGUI.curry CoosyShowObserve.curry Observe.curry \
	  CoosyTrace.curry CoosyDerive.curry
	$(REPL) $(REPL_OPTS) :load CoosyGUI :save :quit

# clean up all auxiliary files:
.PHONY: clean
clean:
	$(CLEANCURRY)
	rm -f CoosyGUI

=== tools/ui/Makefile ===
# precompile all modules of the library
# to avoid recompilation when they are used:

CURRYEXEC=`pwd`/../../bin/curry

UILIBS = GUI.curry GUI2HTML.curry HTML.curry \
	 TypedUI2GUI.curry TypedUI2HTML.curry \
	 UI.curry UI2GUI.curry UI2HTML.curry \
	 Json.curry Parse.curry SpicyWeb.curry

LIB_PL    = `echo $(UILIBS:%.curry=.curry/pakcs/%.pl)`

.PHONY: all
all: pl

.PHONY: pl
pl:
	@${MAKE} $(LIB_PL)

# generate all Prolog translations:
.curry/pakcs/%.pl: %.curry
	rm -f $@ && "$(CURRYEXEC)" --quiet :compile $* :quit

# clean all generated files
.PHONY: clean
clean:
	../../bin/cleancurry -r

=== debian/changelog ===
pakcs (1.14.1-4) unstable; urgency=medium

  * debian/rules:
    + Don't run unit tests on 32bit hardware. The SWI-Prolog's stack size is to
      small for it on 32bit platforms.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 08 Feb 2017 17:18:04 +0100

pakcs (1.14.1-3) unstable; urgency=medium

  * debian/patches:
    + Add 0055-More-error-exit-codes-are-set.patch,
          0056-CASS-tool-updated-containing-new-analyses.patch,
          0057-Makefiloe-changed-for-package-installation-verbose-m.patch,
          0058-Tools-and-libs-updated.patch.
      Add more exit points with exit code.
      Support running tests in verbose mode.
    + Add 0059-lockfile-command-replaced-by-lockfile-create-remove.patch;
      use lockfile-progs instead of procmail's lockfile.
    + Add 0060-Bug-for-loading-libraries-with-SWI-Prolog-fixed-SWI-.patch,
      0061-Release-notes-and-build-version-number-adapted.patch; fix library
      loading issue with SWI Prolog.
    + Add 0062-tools-and-libs-updated.patch,
          0063-Check-for-existence-of-home-directory-extended.patch,
          0064-tools-updated.patch.
      Check existence of home directory + release notes updates.
    + Add 0065-tools-updated-clean-up-after-runtest-added-in-Makefi.patch,
          0066-noreadline-added-to-CHR-tests.patch,
          0067-pakcs-script-slightly-improved-w.r.t-home-dir-checki.patch.
      Prevent test suite from attempting to create non-existent home directory.
  * debian/control:
    + Add to B-D and R (pakcs): sqlite3. Test suite also tests some database
      functionalities based on SQLite 3. Same functionalities at runtime are
      only available if SQLite 3 is installed.
    + Update versioned B-D for curry-libs and curry-tools. Various fixes for
      the test runs shipped in those new package revisions.
    + Add to B-D and D (pakcs): lockfile-progs. Required by IOExts in curry-libs.
    + Typo fix in package SYNOPSIS. (Closes: #852950).
    + Add to S (pakcs): tk.
  * debian/rules:
    + Enable unit tests (via runtestverbose CHECK target).
    + Make sure that cleancurry is available via PAKCSHOME/bin at build time.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2017 09:22:38 +0100

pakcs (1.14.1-2) unstable; urgency=medium

  * debian/control:
    + With curry-base 0.4.2-3 we don't need to enforce UTF-8 locale anymore. Now
      enforced in the curry-base code directly.
    + Version-bump B-Ds for curry-libs and curry-tools to 1.0.1. Required for
      new PAKCSINSTALLDIR handling.
    + Add D (pakcs): swi-prolog-nox (>= 7.2.3).
    + Update versioned B-D / D on curry-frontend. Make sure that 0.4.2-2~ or
      higher is installed, to assure having the UTF-8 fix on board.
    + Make package team-maintained (Debian Curry Maintainers, pkg-curry team on
      Alioth). Move myself to Uploaders: field. Add Michael Hanus (upstream) to
      Uploaders: field.
  * debian/rules:
    + Use cleanall target for upstream clean-up.
    + Additionally clean-up bin/, currytools/, debian/build/ and
      scripts/makesavedstate on clean target.
    + Set PAKCSINSTALLDIR and hand it over to upstream Makefile's build target.
    + Remove commented out DEB_MAKE_INSTALL_TARGET. Disable
      DEB_MAKE_CHECK_TARGET for now; it consumes a lot of time, memory and
      generates no output.
  * debian/patches:
    + Cherry-pick 0044-Addition-of-constant-for-package-install-dir-added.patch,
      0045-Installation-extended-to-PAKCSINSTALLDIR.patch,
      0048-Tools-update.patch, 0049-Tools-update.patch and
      0050-References-to-cymake-replaced-by-pakcs-frontend.patch from upstream.
      Adds PAKCSINSTALLDIR variable support to pakcs's main Makefile.
    + Drop unused patch file 0027-libs-updated.patch.
    + Add 0051-Prolog-module-imports-changed-to-avoid-SWI-errors.patch
      0052-pakcs-cymake-occurrence-removed.patch
      0053-SICStus-compilation-adapted-to-new-scheme-for-SWI-Pr.patch
      0054-Fix-for-loading-run-time-libraries-in-SICStus-back-e.patch
      (cherry-picked from upstream). Fix module loading in SWI Prolog.
    + Update 2001_run-cleancurry-from-inside-debian-subfolder.patch.
  * debian/pakcs.{install,links}:
    + Drop work-around for broken symlinks. Upstream now has relative symlinks.
  * debian/copyright:
    + Update copyright attributions.
  * debian/pakcs.lintian-overrides:
    + Fix typo in override comment.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 27 Jan 2017 14:23:32 +0100

pakcs (1.14.1-1) unstable; urgency=low

  * Initial release to Debian. (Closes: #840519).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 23 Dec 2016 16:49:39 +0100

=== debian/control ===
Source: pakcs
Section: devel
Priority: extra
Maintainer: Debian Curry Maintainers <pkg-curry-maintainers@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Michael Hanus <mh@informatik.uni-kiel.de>,
Build-Depends: cdbs,
 debhelper (>= 9),
 quilt,
 curry-frontend (>= 0.4.2-2~),
 curry-libs-source (>= 1.0.1-3~),
 curry-tools-source (>= 1.0.1+dfsg1-3~),
 swi-prolog-nox (>= 7.2.3),
 sqlite3,
 lockfile-progs,
Standards-Version: 3.9.8
Homepage: https://www-ps.informatik.uni-kiel.de/~pakcs/
Vcs-Browser: https://anonscm.debian.org/git/pkg-curry/pakcs.git
Vcs-Git: https://anonscm.debian.org/git/pkg-curry/pakcs.git

Package: pakcs
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 curry-frontend (>= 0.4.2-2~),
 libjs-prototype (>= 1.6),
 swi-prolog-nox (>= 7.2.3),
 lockfile-progs,
Recommends:
 sqlite3,
Suggests:
 tk
Description: Portland Aachen Kiel Curry Compiler
 PAKCS is an implementation of the multi-paradigm declarative language
 Curry jointly developed by the Portland State University, the Aachen
 University of Technology, and the University of Kiel. Although this is
 not a highly optimized implementation but based on a high-level
 compilation of Curry programs into Prolog programs, it is not a toy
 implementation: PAKCS has been used for a variety of applications so far
 (e.g., graphical programming environments, an object-oriented front-end
 for Curry, partial evaluators, database applications, HTML programming
 with dynamic web pages, prototyping embedded systems). The size of all
 current Curry applications implemented with PAKCS amounts to more than
 150,000 lines (or 8 mbytes) of program code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

VERBOSE=1

DISTPKGINSTALL=yes
CURRYFRONTEND=/usr/bin/curry-frontend
CURRYLIBSDIR=$(CURDIR)/debian/build/curry-libs
CURRYTOOLSDIR=$(CURDIR)/debian/build/curry-tools
PAKCSINSTALLDIR=/usr/lib/pakcs

# Only run unit tests on 64bit architectures for the reason given below.
#
# Quoting... http://www.swi-prolog.org/pldoc/man?section=64bits
#
# First of all, SWI-Prolog's addressing of the Prolog stacks does not
# cover the whole address space due to the use of type tag bits and
# garbage collection flags. On 32-bit hardware the stacks are limited to
# 128 MB each. This tends to be too low for demanding applications on
# modern hardware. On 64-bit hardware the limit is 2^32 times higher,
# exceeding the addressing capabilities of today's CPUs and operating
# systems. This implies Prolog can be started with stack sizes that use
# the full capabilities of your hardware.

ifeq (,$(filter 32,$(DEB_HOST_ARCH_BITS)))
DEB_MAKE_CHECK_TARGET = runtestverbose
else
DEB_MAKE_CHECK_TARGET =
endif
DEB_MAKE_BUILD_TARGET = all DISTPKGINSTALL=$(DISTPKGINSTALL) CURRYFRONTEND=$(CURRYFRONTEND) CURRYLIBSDIR=$(CURRYLIBSDIR) CURRYTOOLSDIR=$(CURRYTOOLSDIR) PAKCSINSTALLDIR=$(PAKCSINSTALLDIR)
DEB_MAKE_CLEAN_TARGET = cleanall

DEB_DH_INSTALLCHANGELOGS_ARGS = RELNOTES.txt

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

pre-build::
	# obtain lib-trunk folder content...
	if [ ! -d "debian/build/curry-libs" ]; then \
	    mkdir -p debian/build/curry-libs/; \
	    cd debian/build/curry-libs && tar xf /usr/src/curry-libs-source.tar.xz && cd - 1>/dev/null; \
	fi

	# obtain currytools folder content...
	if [ ! -d "debian/build/curry-tools" ]; then \
	    mkdir -p debian/build/curry-tools/; \
	    cd debian/build/curry-tools && tar xf /usr/src/curry-tools-source.tar.xz && cd - 1>/dev/null; \
	fi

	# deploy Debianic pakcsinitrc into source tree...
	cp debian/pakcsinitrc .

	# make sure cleancurry is available in PAKCSHOME/bin, required for test suite
	mkdir -p bin/
	ln -fs ../scripts/cleancurry.sh bin/cleancurry

binary-post-install/pakcs::
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/cleancurry
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs-fcypp
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs-makecgi
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/*.sh
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/configure-pakcs
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/makesavedstate

	# remove superfluous LICENSE files
	rm debian/pakcs/usr/lib/pakcs/currytools/LICENSE

	# remove superfluous upstream VCS related files
	rm debian/pakcs/usr/lib/pakcs/currytools/peval/.gitignore

clean::
	-rm -R bin/
	-rm -R currytools/
	-rm -R debian/build/
	-rm  scripts/makesavedstate

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
